<?php
class Irc extends Odbierajka
	{
	public $nick, $ident, $realname, $channel, $powitanie, $oczekiwanie, $idletime;

	function __construct($host, $port, $nick, $ident, $realname, $channel)
		{
		global $engine;
		$this->engine=$engine;
		$this->id=$GLOBALS['odbierajkiid'];
		$GLOBALS['odbierajkiid']++;
		$this->re=-1;
		$this->host=$host;
		$this->port=$port;
		$this->nick=$nick;
		$this->ident=$ident;
		$this->realname=$realname;
		$this->channel=$channel;
		$this->oczekiwanie=time()-1;
		$this->engine->log('['.$this->id.'] Log: Stworzono Ircowa odbierajke.');
		}

	function polaczony()
		{
		$return=0;
		if($this->powitanie!=TRUE)
			{
			$this->nick($this->nick);
  			$this->user($this->ident, 'cremmy.ekrakow.net', 'Sfg', $this->realname);
			$this->join($this->channel);
			$this->powitanie=TRUE;
			}
		if($tekst=$this->engine->in($this->socket))		// Jesli mamy tekst...
			{
			$tekst=explode(' ', $tekst, 3);			// To go obrabiamy
			if(strlen($tekst[0])<=0)
				{
				$this->engine->log('['.$this->id.'] Log: Pusty komunikat.');
				}
			else if(strtolower($tekst[0])=='ping')		// Jeli trzeba to odpowiadamy na ping
				{
				$this->serv_ping($tekst[1], substr($tekst[2], 1));
				}
			else
				{
				$this->raw(implode(' ', $tekst));	// W przeciwnym razie przesylamy do dalszej obrbki
				//$GLOBALS[$this->id]['tmp']=$GLOBALS[$this->id]['tmp'].implode(' ', $tekst);	// Zakomentowa lini wyej i odkomentowa te, 'bufor' tekstu przed przesaniem go do obrbki
				//$tmp=explode(':', $GLOBALS[$this->id]['tmp']);				// Teoretycznie zapobiegnie urwanym tekstom, praktycznie tak czy inaczej bd jakie urwace d;
				//if(count($tmp)>=3)
				//	{
				//	$this->raw($GLOBALS[$this->id]['tmp']);
				//	$GLOBALS[$this->id]['tmp']='';
				//	}
				}
			$return=1;
			}
		if($this->idletime!=time())
			{
			$this->idletime=time();
			$this->resp_idle($this->channel);
			}
		return $return;
		}

	function polacz()
		{
		if($this->oczekiwanie==0)
			{
			$this->engine->log('['.$this->id.'] Log: Polaczenie zerwane, ponawianie za '.(15*($this->re+1)).'s.');
			$this->oczekiwanie=time()+15*($this->re+1);
			}
		else if($this->oczekiwanie<time())
			{
			@fclose($this->socket);
			$this->engine->log('['.$this->id.'] Log: Laczenie z '.$this->host.':'.$this->port."\n\t".'Pozostalo prob: '.($GLOBALS['re_max']-$this->re-1).'.');
			$this->re++;
			$this->powitanie=FALSE;
			$this->oczekiwanie=0;
			if($this->socket=@fsockopen($this->host, $this->port, $erno, $errstr, 10))
				{
				stream_set_blocking($this->socket, 0);
				echo $this->engine->log('['.$this->id.'] Log: Stworzono socketa, host: '.$this->host.', port: '.$this->port.'.');
				//echo "\n\t".'Id: '.$this->id;
				$this->lastre=time();
				return 1;
				}
			else
				{
				echo $this->engine->log('['.$this->id.'] Log: Nie udalo sie stworzyc socketa.');
				return 0;
				}
			}
		}

	function raw($string)		// Obrobka tekstu
		{
/*********************************************************/
/** $string[0][0][0] <- sender				**/
/** $string[0][0][1] <- jego host			**/
/** $string[0][1]    <- akcja				**/
/** $string[0][2]    <- odbiorca			**/
/** $string[1][0]    <- akcja		(privmsg)	**/
/** $string[1][1]    <- tekst/parametr	(privmsg)	**/
/*********************************************************/

		$string=str_replace("\n", '', str_replace("\r", '', $string));
		$string=explode(' :', $string, 2);
		$string[0]=explode(' ', $string[0]);
		if(substr($string[1], 0, 1)=='')
			{
			$string[1]=str_replace('', '', $string[1]);
			$string[1]=explode(' ', $string[1], 2);
			}
		$string[0][0]=explode('!', $string[0][0]);
		$string[0][0][0]=substr($string[0][0][0], 1);
		//print_r($string);
		switch(strtolower($string[0][1]))
			{
			case 'privmsg':
				if(is_array($string[1]))
					{
					if($string[1][0]=='ACTION')
						$this->resp_action($string[0][0][0], $string[0][2] , $string[0][0][1], $string[1][1]);
					else if($string[1][0]=='PING')
						$this->resp_ping($string[0][0][0], $string[0][2] , $string[0][0][1], $string[1]);
					}
				else
					{
					if($string[0][2]==$this->nick)
						$this->resp_privmsg($string[0][0][0], $string[0][0][1], $string[1]);
					else
						$this->resp_msg($string[0][0][0], $string[0][2], $string[0][0][1], $string[1]);
					}
			break;

			case 'join':
				if($string[0][0][0]==$this->nick)
					$this->resp_self_join($string[1]);									// Reakcja na dolaczenie
				else
					$this->resp_join($string[0][0][0], $string[1], $string[0][0][1]);					// Reakcja na dolaczenie kogos
			break;

			case 'quit';
				if($string[0][0][0]==$this->nick)
					$this->resp_self_quit();									// Reakcja na dolaczenie
				else
					$this->resp_quit($string[0][0][0], $string[0][0][1], $string[1]);	
			break;

			case 'part':
				if($string[0][0]==$this->nick)
					$this->resp_self_part($string[0][2]);								// Reakcja na odejscie
				else
					$this->resp_part($string[0][0][0], $string[0][2] , $string[0][0][1], $string[1]);			// Reakcja na odejscie kogos
			break;

			case 'kick':
				if($string[0][3]==$this->nick)
					$this->resp_self_kick($string[0][0][0], $string[0][2] , $string[0][0][1], $string[1]);		// Reakcja na kicka
				else
					$this->resp_kick($string[0][0][0], $string[0][2] , $string[0][0][1], $string[3], $string[1]);	// Reakcja na kicka kogos
			break;

			case 'mode':
				if($string[0][4]==$this->nick)
					$this->resp_self_mode($string[0][0][0], $string[0][2] , $string[0][0][1], $string[0][3]);		// Reakcja na zmiane moda
				else
					$this->resp_mode($string[0][0][0], $string[0][2] , $string[0][0][1], $string[0][3], $string[0][4]);	// Reakcja na zmiane czyjegos moda
			break;

			case 'notice':
				if($string[0][2]=='AUTH')
					$this->resp_notice_auth($string[0][0][0], $string[0][0][1], $string[1]);
				else
					$this->resp_notice($string[0][0][0], $string[0][2] , $string[0][0][1], $string[1]);
			break;

			case 'topic':
				$this->resp_topic($string[0][0][0], $string[0][2] , $string[0][0][1], $string[1]);
			break;

			default:
				if(round($string[0][1])>0)
					$this->resp_num($string[0][0][0], $string[0][0][1], $string[1], round($string[0][1]));
			break;
			}
		}

/******************************************************************** Wiadomosc na kanale *********/
	function resp_msg($sender, $channel, $host, $string)
		{
		global $engine;
		@include 'resp/msg.php';
		}
/******************************************************************** Wiadomosc prywatna **********/
	function resp_privmsg($sender, $host, $string)
		{
		global $engine;
		@include 'resp/privmsg.php';
		}
/******************************************************************** Ping od uzytkownika *********/
	function resp_ping($sender, $host, $string)
		{
		global $engine;
		@include 'resp/ping.php';
		}
/******************************************************************** Ping od serwera *************/
	function resp_serv_ping($sender, $string)
		{
		global $engine;
		@include 'resp/serv_ping.php';
		}
/******************************************************************** Akcja  **********************/
	function resp_action($sender, $channel, $host, $string)
		{
		global $engine;
		@include 'resp/action.php';
		}
/******************************************************************** Ktos dolaczyl ***************/
	function resp_join($sender, $channel, $host)
		{
		global $engine;
		@include 'resp/join.php';
		}
/******************************************************************** Bot dolaczyl ****************/
	function resp_self_join($channel)
		{
		global $engine;
		@include 'resp/self_join.php';
		}
/******************************************************************** Ktos odszedl ****************/
	function resp_part($sender, $channel, $host, $string)
		{
		global $engine;
		@include 'resp/part.php';
		}
/******************************************************************** Bot odszedl *****************/
	function resp_self_part($channel)
		{
		global $engine;
		@include 'resp/self_part.php';
		}
/******************************************************************** Ktos quitnal ****************/
	function resp_quit($sender, $host, $string)
		{
		global $engine;
		@include 'resp/quit.php';
		}
/******************************************************************** Bot quitnal *****************/
	function resp_self_quit()
		{
		global $engine;
		@include 'resp/self_quit.php';
		}
/******************************************************************** Ktos zostal kickniety *******/
	function resp_kick($sender, $channel, $host, $who, $string)
		{
		global $engine;
		@include 'resp/kick.php';
		}
/******************************************************************** Bot zostal kickniety ********/
	function resp_self_kick($sender, $channel, $host, $string)
		{
		global $engine;
		@include 'resp/self_kick.php';
		}
/******************************************************************** Ktos zostal kickniety *******/
	function resp_mode($sender, $channel, $host, $mode, $who)
		{
		global $engine;
		@include 'resp/mode.php';
		}
/******************************************************************** Bot zostal kickniety ********/
	function resp_self_mode($sender, $channel, $host, $mode)
		{
		global $engine;
		@include 'resp/self_mode.php';
		}
/******************************************************************** Notice **********************/
	function resp_notice($sender, $channel, $host, $string)
		{
		global $engine;
		@include 'resp/notice.php';
		}
/******************************************************************** Notice Auth *****************/
	function resp_notice_auth($sender, $host, $string)
		{
		global $engine;
		@include 'resp/notice_auth.php';
		}
/******************************************************************** Zmiana tematu ***************/
	function resp_topic($sender, $host, $string)
		{
		global $engine;
		@include 'resp/topic.php';
		}
/******************************************************************** Numerek *********************/
	function resp_num($sender, $host, $string, $num)
		{
		global $engine;
		@include 'resp/num.php';
		}
/******************************************************************** Oczekiwanie *****************/
	function resp_idle($channel)
		{
		global $engine;
		@include 'resp/idle.php';
		}
/**************************** Wiadomosci **********************/
/**************************** Connection Registration *********/
	function pass($string)
		{
		if(strlen($string)>0)
			$this->engine->out($this->socket, 'PASS '.$string);
		}
	function nick($newnick, $oldnick='')
		{
		if(strlen($oldnick)>0)
			$this->engine->out($this->socket, ':'.$oldnick.' NICK '.$newnick);
		else
			$this->engine->out($this->socket, 'NICK '.$newnick);
		}
	function user($username, $hostname, $servername, $realname)
		{
		if(strlen($username)>0 && strlen($realname)>0)
			$this->engine->out($this->socket, 'USER '.$username.' '.$hostname.' '.$servername.' :'.$realname);
		}
	function oper($username, $password)
		{
		if(strlen($username)>0 && strlen($password)>0)
			$this->engine->out($this->socket, 'OPER '.$username.' :'.$password);
		}
	function quit($string='')
		{
		if(strlen($string)>0)
			$this->engine->out($this->socket, 'QUIT :'.$string.' ');
		else
			$this->engine->out($this->socket, 'QUIT :Quit ');
		}
/**************************************************************/
/**************************** Channel operations **************/
	function join($channel, $key='')
		{
		if(strlen($channel)>0 && strlen($key)>0)
			$this->engine->out($this->socket, 'JOIN '.$channel.' '.$key);
		else
			$this->engine->out($this->socket, 'JOIN '.$channel);
		}
	function part($channel, $string)
		{
		if(strlen($channel)>0 && strlen($string)>0)
			$this->engine->out($this->socket, 'PART '.$channel.' :'.$string);
		}
	function mode($channel, $mode, $who)
		{
		if(strlen($channel)>0 && strlen($mode)>0 && strlen($who)>0)
			$this->engine->out($this->socket, 'MODE '.$channel.' '.$mode.' '.$who);
		}
	function topic($channel, $topic='')
		{
		if(strlen($channel)>0)
			if(strlen($topic)>0)
				$this->engine->out($this->socket, 'TOPIC '.$channel.' '.$topic);
			else
				$this->engine->out($this->socket, 'TOPIC '.$channel);
		}
	function names($channel='')
		{
		if(strlen($channel)>0)
			$this->engine->out($this->socket, 'NAMES '.$channel);
		else
			$this->engine->out($this->socket, 'NAMES');
		}
	function list_($channel='')
		{
		if(strlen($channel)>0)
			$this->engine->out($this->socket, 'LIST '.$channel);
		else
			$this->engine->out($this->socket, 'LIST');
		}
	function invite($nickname, $channel)
		{
		if(strlen($nickname)>0 && strlen($channel))
			$this->engine->out($this->socket, 'INVITE '.$nickname.' '.$channel);
		}
	function kick($channel, $nickname, $string='Kick!')
		{
		if(strlen($channel)>0 && strlen($who)>0)
			$this->engine->out($this->socket, 'KICK '.$channel.' '.$nickname.' :'.$string);
		}
/**************************************************************/
/**************************** Server queries and commands *****/
	function version($server='')
		{
		if(strlen($server)>0)
			$this->engine->out($this->socket, 'VERSION '.$server);
		else
			$this->engine->out($this->socket, 'VERSION');
		}
	function stats($query, $server='')
		{
		if(strlen($query)>0)
			if(strlen($server)>0)
				$this->engine->out($this->socket, 'STATS '.$server);
			else
				$this->engine->out($this->socket, 'STATS');
		}
	function links($mask, $server='')
		{
		if(strlen($mask)>0)
			if(strlen($server)>0)
				$this->engine->out($this->socket, 'LINKS '.$mask.' '.$server);
			else
				$this->engine->out($this->socket, 'LINKS '.$mask);
		}
	function time($server='')
		{
		if(strlen($server)>0)
			$this->engine->out($this->socket, 'TIME '.$server);
		else
			$this->engine->out($this->socket, 'TIME');
		}
	function connect($server, $port=0, $remoteserv)
		{
		if(strlen($server)>0)
			if($port>0 && strlen($remoteserv)>0)
				$this->engine->out($this->socket, 'CONNECT '.$server.' '.$port.' '.$remoteserv);
			else
				$this->engine->out($this->socket, 'CONNECT '.$server);
		}
	function trace($server='')
		{
		if(strlen($server)>0)
			$this->engine->out($this->socket, 'TRACE '.$server);
		else
			$this->engine->out($this->socket, 'TRACE');
		}
	function admin($server='')
		{
		if(strlen($server)>0)
			$this->engine->out($this->socket, 'ADMIN '.$server);
		else
			$this->engine->out($this->socket, 'ADMIN');
		}
	function info($server='')
		{
		if(strlen($server)>0)
			$this->engine->out($this->socket, 'INFO '.$server);
		else
			$this->engine->out($this->socket, 'INFO');
		}
/**************************************************************/
/**************************** Sending messages ****************/
	function privmsg($channel, $string)
		{
		if(strlen($channel)>0 && strlen($string)>0)
			$this->engine->out($this->socket, 'PRIVMSG '.$channel.' :'.str_replace('na', '5na1', $string));
		}
/**************************** Odmiany privmsg *****************/
	function action($channel, $string)
		{
		if(strlen($channel)>0 && strlen($string)>0)
			$this->engine->out($this->socket, 'PRIVMSG '.$channel.' :'."\01".'ACTION '.$string."\01");
		}
	function privmsg_ping($channel, $string)
		{
		if(strlen($channel)>0 && strlen($string)>0)
			$this->engine->out($this->socket, 'PRIVMSG $channel :'."\01".'PING '.$string."\01");
		}
	function privmsg_pong($channel, $string)
		{
		if(strlen($channel)>0 && strlen($string)>0)
			$this->engine->out($this->socket, 'PRIVMSG '.$channel.' :'."\01".'PONG '.$string."\01");
		}
/**************************************************************/
	function notice($channel, $string)
		{
		if(strlen($channel)>0 && strlen($string)>0)
			$this->engine->out($this->socket, 'NOTICE '.$channel.' :'.$string);
		}
/**************************************************************/
/**************************** User based queries **************/
	function who($mask, $o='')
		{
		if(strlen($mask)>0)
			if(strlen($o)>0)
				$this->engine->out($this->socket, 'WHO '.$mask.' '.$o);
			else
				$this->engine->out($this->socket, 'WHO '.$mask);
		}
	function whois($nickname, $server='')
		{
		if(strlen($nickname)>0)
			if(strlen($server)>0)
				$this->engine->out($this->socket, 'WHOIS '.$server.' '.$nickname);
			else
				$this->engine->out($this->socket, 'WHOIS '.$nickname);
		}
	function whowas($nickname, $count=0, $server='')
		{
		if(strlen($nickname)>0)
			if($count>0)
				if(strlen($server)>0)
					$this->engine->out($this->socket, 'WHOWAS '.$nickname.' '.$count.' '.$server);
				else
					$this->engine->out($this->socket, 'WHOWAS '.$nickname.' '.$count);
			else
				$this->engine->out($this->socket, 'WHOWAS '.$nickname);
		}
/**************************************************************/
/************************************** Miscellaneous messages*/
	function kill($nickname, $string)
		{
		if(strlen($nickname)>0 && strlen($string)>0)
			$this->engine->out($this->socket, 'KILL '.$nickname.' :'.$string);
		}
	function ping($sender, $string)
		{
		if(strlen($sender)>0 && strlen($string)>0)
			$this->engine->out($this->socket, 'PING '.$sender.' '.$string);
		}
	function pong($sender, $string)
		{
		if(strlen($sender)>0)
			if(strlen($string)>0)
				$this->engine->out($this->socket, 'PONG '.$sender.' '.$string);
			else
				$this->engine->out($this->socket, 'PONG '.$sender);
		}
	function error($string)
		{
		if(strlen($string)>0)
			$this->engine->out($this->socket, 'ERROR '.$string);
		}
/**************************************************************/
/************************************** Optionals *************/
	function away($string)
		{
		if(strlen($string)>0)
			$this->engine->out($this->socket, 'AWAY '.$string);
		}
	function rehash()
		{
		if(strlen($string)>0)
			$this->engine->out($this->socket, 'REHASH');
		}
	function restart()
		{
		if(strlen($string)>0)
			$this->engine->out($this->socket, 'RESTART');
		}
	function summon($user, $server='')
		{
		if(strlen($user)>0)
			if(strlen($server)>0)
				$this->engine->out($this->socket, 'SUMMON '.$user.' '.$server);
			else
				$this->engine->out($this->socket, 'SUMMON '.$user);
		}
	};
?>